Index: /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs
===================================================================
--- /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs	(revision 11117)
+++ /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.Designer.cs	(revision 11118)
@@ -52,9 +52,8 @@
       // textBox
       // 
-      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.textBox.BackColor = System.Drawing.Color.White;
-      this.textBox.Font = new System.Drawing.Font("Consolas", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
       this.textBox.Location = new System.Drawing.Point(3, 30);
       this.textBox.Multiline = true;
@@ -67,6 +66,6 @@
       // formattersComboBox
       // 
-      this.formattersComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.formattersComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.formattersComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
       this.formattersComboBox.FormattingEnabled = true;
Index: /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.cs
===================================================================
--- /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.cs	(revision 11117)
+++ /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionView.cs	(revision 11118)
@@ -78,5 +78,4 @@
       UpdateTextbox();
     }
-
   }
 }
Index: able/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeHierarchicalFormatter.cs
===================================================================
--- /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Formatters/SymbolicExpressionTreeHierarchicalFormatter.cs	(revision 11117)
+++ 	(revision )
@@ -1,93 +1,0 @@
-﻿#region License Information
-
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-
-#endregion
-
-using System.IO;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.SymbolicExpressionTreeEncoding {
-  [Item("Hierarchical Formatter", "Formatter for symbolic expression trees that uses special characters for drawing a tree in text-mode.")]
-  public sealed class SymbolicExpressionTreeHierarchicalFormatter : NamedItem, ISymbolicExpressionTreeStringFormatter {
-    private SymbolicExpressionTreeHierarchicalFormatter(SymbolicExpressionTreeHierarchicalFormatter original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SymbolicExpressionTreeHierarchicalFormatter(this, cloner);
-    }
-
-    public SymbolicExpressionTreeHierarchicalFormatter() :
-      base("Hierarchical Formatter", "Formatter for symbolic expression trees that uses special characters for drawing a tree in text-mode.") { }
-
-    public string Format(ISymbolicExpressionTree symbolicExpressionTree) {
-      var sw = new StringWriter();
-      RenderTree(sw, symbolicExpressionTree);
-      return sw.ToString();
-    }
-
-    private static void RenderTree(TextWriter writer, ISymbolicExpressionTree tree) {
-      RenderNode(writer, tree.Root, string.Empty);
-    }
-
-    public static void RenderNode(TextWriter writer, ISymbolicExpressionTreeNode node, string prefix) {
-      string label = node.ToString();
-      writer.Write(label);
-      if (node.SubtreeCount > 0) {
-        var padding = prefix + new string(' ', label.Length);
-        for (int i = 0; i != node.SubtreeCount; ++i) {
-          char connector, extender = ' ';
-          if (i == 0) {
-            if (node.SubtreeCount > 1) {
-              connector = RenderChars.JunctionDown;
-              extender = RenderChars.VerticalLine;
-            } else {
-              connector = RenderChars.HorizontalLine;
-              extender = ' ';
-            }
-          } else {
-            writer.Write(padding);
-            if (i == node.SubtreeCount - 1) {
-              connector = RenderChars.CornerRight;
-              extender = ' ';
-            } else {
-              connector = RenderChars.JunctionRight;
-              extender = RenderChars.VerticalLine;
-            }
-          }
-          writer.Write(string.Concat(connector, RenderChars.HorizontalLine));
-          var newPrefix = string.Concat(padding, extender, ' ');
-          RenderNode(writer, node.GetSubtree(i), newPrefix);
-        }
-      } else
-        writer.WriteLine();
-    }
-
-    // helper class providing characters for displaying a tree in the console
-    public static class RenderChars {
-      public const char JunctionDown = '┬';
-      public const char HorizontalLine = '─';
-      public const char VerticalLine = '│';
-      public const char JunctionRight = '├';
-      public const char CornerRight = '└';
-    }
-  }
-}
Index: /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj
===================================================================
--- /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 11117)
+++ /stable/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.csproj	(revision 11118)
@@ -135,5 +135,4 @@
     <Compile Include="Creators\RampedHalfAndHalfTreeCreator.cs" />
     <Compile Include="Formatters\SymbolicExpressionTreeGraphvizFormatter.cs" />
-    <Compile Include="Formatters\SymbolicExpressionTreeHierarchicalFormatter.cs" />
     <Compile Include="Interfaces\IReadOnlySymbol.cs" />
     <Compile Include="Interfaces\ISymbolicExpressionGrammar.cs" />
Index: /stable/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/TextualSymbolicDataAnalysisModelView.designer.cs
===================================================================
--- /stable/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/TextualSymbolicDataAnalysisModelView.designer.cs	(revision 11117)
+++ /stable/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/TextualSymbolicDataAnalysisModelView.designer.cs	(revision 11118)
@@ -48,5 +48,5 @@
       this.SuspendLayout();
       // 
-      // symbolicExpressionTreeView
+      // expressionTreeView
       // 
       this.symbolicExpressionTreeView.AllowDrop = true;
@@ -55,15 +55,16 @@
       this.symbolicExpressionTreeView.Dock = System.Windows.Forms.DockStyle.Fill;
       this.symbolicExpressionTreeView.Location = new System.Drawing.Point(0, 0);
-      this.symbolicExpressionTreeView.Name = "symbolicExpressionTreeView";
+      this.symbolicExpressionTreeView.Name = "expressionTreeView";
       this.symbolicExpressionTreeView.ReadOnly = false;
       this.symbolicExpressionTreeView.Size = new System.Drawing.Size(352, 413);
       this.symbolicExpressionTreeView.TabIndex = 0;
       // 
-      // TextualSymbolicDataAnalysisModelView
+      // SymbolicExpressionModelView
       // 
       this.AllowDrop = true;
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.Controls.Add(this.symbolicExpressionTreeView);
-      this.Name = "TextualSymbolicDataAnalysisModelView";
+      this.Name = "SymbolicExpressionModelView";
       this.Size = new System.Drawing.Size(352, 413);
       this.ResumeLayout(false);